{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "# О языке #\n",
    "\n",
    "Давайте сначала немножко поговорим об истории языка."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "В конце 80-х годов прошлого века сотрудник голландского центра математики и информатики Гвидо ван Россум решил создать свой собственный язык."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "![guido.jpg](guido.jpg)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Основной целью он ставил создать язык простой и выразительный, на котором было бы просто писать код.\n",
    "\n",
    "В 1991 году он опубликовал исходники языка, который получил название Python. \n",
    "\n",
    "Не в честь известного всем вида пресмыкающихся, а в честь популярного телешоу 70-х годов прошлого века \"Летающий цирк Монти Пайтона\".\n",
    "\n",
    "Однако это не помешало змее стать маскотом, символом языка, а также присутствовать на логотипах языка и связанных с ним проектах."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "![logo.png](logo.svg)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Сейчас, спустя много лет, мы видим, что у Гвидо получилось.\n",
    "\n",
    "У него получилось создать интерпретируемый язык с динамической типизацией и автоматической сборкой мусора, на котором действительно приятно писать код."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Читая код \"на питоне\", мы практически читаем книгу на английском языке.\n",
    "\n",
    "Конечно это преувеличение, однако Python действительно выделяется в этом отношении.\n",
    "\n",
    "Также за годы существования языка вокруг него сложилось огромное сообщество, и была написана масса готовых библиотек на все случаи жизни.\n",
    "\n",
    "Я ставлю цель сделать вас частью этого сообщества по завершению этого курса."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Разработчики языка, выпустили третью версию, обратно несовместимую со второй. Это было сделано специально для того, чтобы решить некоторые архитектурные недостатки второй версии языка. Это получилось сделать, однако обратная несовместимость привела к тому, что до сих пор многие продакшн-системы используют Python версии 2. Но в 2020 году настал дедлайн и официальная поддержка Python 2 прекратилась, поэтому новые проекты стоит начинать именно на Python'е 3. Тем более, если вдруг вам потребуется узнать отличие Python'а 2 от Python'а 3, вы сможете это сделать достаточно быстро за 1–2 дня. Всё это есть в Интернете. На курсе я буду рассказывать про Python 3, а именно Python версии 3.6."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Python — это название спецификации языка, основная его реализация написана на языке C, называется CPython. Есть и другие реализации спецификации языка Python такие, как IronPython для .NET, либо PyPy, который добавляет JIT-компиляцию коду. Однако в курсе, когда я буду говорить слово Python, я имею в виду именно реализацию на C — CPython. Исходный код CPython открыт и доступен по ссылке на github https://github.com/python/cpython."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "У Python великолепная документация с большим количеством примеров, которые ставят в пример другим языкам, она также доступна в Интернете по ссылке https://docs.python.org/3.6/."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Развитие языка Python происходит согласно чётко регламентированному процессу создания, обсуждения, отбора и реализации документов PEP.\n",
    "\n",
    "PEP - Python Enhancement Proposal - это предложения по развитию питона https://www.python.org/dev/peps/.\n",
    "\n",
    "Процесс PEP является основным механизмом для предложения новых возможностей и для документирования проектных решений, которые прошли в Python."
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {
    "slideshow": {
     "slide_type": "slide"
    }
   },
   "source": [
    "Теперь, прежде чем начать программировать, нам осталось решить два вопроса.\n",
    "\n",
    "Первый — это как установить Python 3 в систему, и второй — в каком редакторе писать код на Python'е.\n",
    "\n",
    "Давайте разберемся с этими вопросами. [Далее...](Установка%20Python%203.ipynb)"
   ]
  }
 ],
 "metadata": {
  "celltoolbar": "Слайд-шоу",
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.10.12"
  },
  "widgets": {
   "application/vnd.jupyter.widget-state+json": {
    "state": {},
    "version_major": 1,
    "version_minor": 0
   }
  }
 },
 "nbformat": 4,
 "nbformat_minor": 4
}
